﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SpaceTransformationExample
{
    class Camera
    {
        public Vector2 Position { get; set; }
        public float Rotation { get; set; }
        public float Zoom { get; set; }

        private SpriteBatch mSpriteBatch;
        private bool zooming = true;

        public Camera(SpriteBatch sb)
        {
            mSpriteBatch = sb;
            Position = new Vector2(Game1.SCREEN_WIDTH/ 2, Game1.SCREEN_HEIGHT/ 2);
            Rotation = 1.0f;
            Zoom = 0.5f;
        }

        public void Begin()
        {
            mSpriteBatch.Begin();
        }

        public void End()
        {
            mSpriteBatch.End();
        }

        public void Update(GameTime gameTime)
        {
            //if (Zoom > 2)
            //    zooming = false;
            //if (Zoom < 0.5)
            //    zooming = true;

            //if (zooming)
            //{
            //    Zoom += (float)(gameTime.ElapsedGameTime.TotalSeconds * 0.2);
            //}
            //else
            //{
            //    Zoom -= (float)(gameTime.ElapsedGameTime.TotalSeconds * 0.2);

            //}

            //Rotation += (float) (gameTime.ElapsedGameTime.TotalSeconds * 0.5);
        }

        public void Draw(WorldObject obj)
        {
            Vector2 objPosInCameraSpace = obj.PositionInWorldSpace - Position;

            objPosInCameraSpace = new Vector2(objPosInCameraSpace.X * (float)Math.Cos(-Rotation) -
                                              objPosInCameraSpace.Y * (float)Math.Sin(-Rotation),
                                              objPosInCameraSpace.X * (float)Math.Sin(-Rotation) +
                                              objPosInCameraSpace.Y * (float)Math.Cos(-Rotation));
            objPosInCameraSpace *= Zoom;

            Vector2 objPosInScreenSpace = objPosInCameraSpace + new Vector2(Game1.SCREEN_WIDTH / 2, Game1.SCREEN_HEIGHT / 2);


            float rotationInScreenSpace = obj.RotationInWorldSpace - Rotation;

            mSpriteBatch.Draw(obj.Texture, objPosInScreenSpace, null, obj.color, rotationInScreenSpace, obj.TextureOrigin, Zoom, SpriteEffects.None, 0);
        }
    }
}
